public with sharing class SyncWithESRIBatchHelper {

    public static String getChangeRequestQueryForEsriSync() {
        /*SPD3404 CHANGE (Team_Instance__c) Name -> Team_Instance_Code__c*/
        //return 'SELECT Id, Name, Status__c, Change_Effective_Date__c, Request_Type_Change__c, Change_String_Value__c, Source_Position__r.Client_Position_Code__c, Source_Position__r.Name, Source_Position__c, Source_Position__r.Parent_Position__r.Name, Source_Position__r.Parent_Position__r.Client_Position_Code__c, Source_Position__r.Parent_Position__r.Parent_Position__r.Name, Source_Position__r.Parent_Position__r.Parent_Position__r.Client_Position_Code__c, Destination_Position__r.Client_Position_Code__c, Destination_Position__r.Parent_Position__c, Destination_Position__r.Name, Destination_Position__c, Destination_Position__r.Parent_Position__r.Name, Destination_Position__r.Parent_Position__r.Client_Position_Code__c, Destination_Position__r.Parent_Position__r.Parent_Position__r.Name, Destination_Position__r.Parent_Position__r.Parent_Position__r.Client_Position_Code__c,Team_Instance_ID__r.Name,AllZips__c,Source_Position__r.Parent_Position__r.Parent_Position__r.Parent_Position__r.Name, Source_Position__r.Parent_Position__r.Parent_Position__r.Parent_Position__r.Client_Position_Code__c,Source_Position__r.Parent_Position__r.Parent_Position__r.Parent_Position__r.Parent_Position__r.Name, Source_Position__r.Parent_Position__r.Parent_Position__r.Parent_Position__r.Parent_Position__r.Client_Position_Code__c, Destination_Position__r.Parent_Position__r.Parent_Position__r.Parent_Position__r.Name,Destination_Position__r.Parent_Position__r.Parent_Position__r.Parent_Position__r.Client_Position_Code__c, Destination_Position__r.Parent_Position__r.Parent_Position__r.Parent_Position__r.Parent_Position__r.Name,Destination_Position__r.Parent_Position__r.Parent_Position__r.Parent_Position__r.Parent_Position__r.Client_Position_Code__c,Team_Instance_ID__r.Alignment_Period__c,Team_Instance_ID__r.Team__r.Name,Team_Instance_ID__r.Team__r.Type__c FROM Change_Request__c' ;
        return 'SELECT Id, Name, Status__c, Change_Effective_Date__c, Request_Type_Change__c, Change_String_Value__c, Source_Position__r.Client_Position_Code__c, Source_Position__r.Name, Source_Position__c, Source_Position__r.Parent_Position__r.Name, Source_Position__r.Parent_Position__r.Client_Position_Code__c, Source_Position__r.Parent_Position__r.Parent_Position__r.Name, Source_Position__r.Parent_Position__r.Parent_Position__r.Client_Position_Code__c, Destination_Position__r.Client_Position_Code__c, Destination_Position__r.Parent_Position__c, Destination_Position__r.Name, Destination_Position__c, Destination_Position__r.Parent_Position__r.Name, Destination_Position__r.Parent_Position__r.Client_Position_Code__c, Destination_Position__r.Parent_Position__r.Parent_Position__r.Name, Destination_Position__r.Parent_Position__r.Parent_Position__r.Client_Position_Code__c, Team_Instance_ID__r.Name, Team_Instance_ID__r.Team_Instance_Code__c,AllZips__c,Source_Position__r.Parent_Position__r.Parent_Position__r.Parent_Position__r.Name, Source_Position__r.Parent_Position__r.Parent_Position__r.Parent_Position__r.Client_Position_Code__c,Source_Position__r.Parent_Position__r.Parent_Position__r.Parent_Position__r.Parent_Position__r.Name, Source_Position__r.Parent_Position__r.Parent_Position__r.Parent_Position__r.Parent_Position__r.Client_Position_Code__c, Destination_Position__r.Parent_Position__r.Parent_Position__r.Parent_Position__r.Name,Destination_Position__r.Parent_Position__r.Parent_Position__r.Parent_Position__r.Client_Position_Code__c, Destination_Position__r.Parent_Position__r.Parent_Position__r.Parent_Position__r.Parent_Position__r.Name,Destination_Position__r.Parent_Position__r.Parent_Position__r.Parent_Position__r.Parent_Position__r.Client_Position_Code__c,Team_Instance_ID__r.Alignment_Period__c,Team_Instance_ID__r.Team__r.Name, Team_Instance_ID__r.Team__r.Team_Code__c,Team_Instance_ID__r.Team__r.Type__c,Is_Auto_Approved__c,Execution_Status__c FROM Change_Request__c' ;

    }

    /* 
     * @description: Method to give related position map grouped by base position Id
     * @author:      Aditi, SPD-261
     */
    public static Map<Id, list<Related_Position__c>> getRelatedPositionsFromBasePositions(Set<Id> positionIds,Id teamInstance) {
        
        Map<Id, list<Related_Position__c>> overlayPositionsMapByBasePosition = new Map<Id, list<Related_Position__c>>();
        string assignmentStatus = SalesIQUtility.getAssignmentStatusbyTeamInstance(teamInstance);
        set<String> multipleOverlayInstanceSet = new set<String>();
        List<String> RELATED_POSITION_READ_FIELDS = new List<String>{'Base_Position_Team_Instance__c', 'Related_Position_Team_Instance__c',
                                                                    'Related_Position__c', 'Base_Position__c','Assignment_Status__c'};
        
        if(SecurityUtil.checkRead(Related_Position__c.SObjectType, RELATED_POSITION_READ_FIELDS, false) &&
            SecurityUtil.checkRead(Team_Instance__c.SObjectType, new List<String>{'Name', 'Team__c'}, false) &&
            SecurityUtil.checkRead(Team__c.SObjectType, new List<String>{'Name'}, false) && 
            SecurityUtil.checkRead(Position__c.SObjectType, new list<string>{'Client_Position_Code__c','Name','Parent_Position__c'}, false)) {
            
            /*for(Related_Position__c relatedPos : [Select Id, Base_Position_Team_Instance__c, Related_Position_Team_Instance__c, 
                                                Related_Position__c, Base_Position__c, Related_Position_Team_Instance__r.Team_Instance_ID__c,
                                                Related_Position_Team_Instance__r.Team_Instance_ID__r.Name, 
                                                Related_Position_Team_Instance__r.Team_Instance_ID__r.Team__c, Related_Position_Team_Instance__r.Team_Instance_ID__r.Team__r.Name,
                                                Related_Position__r.Client_Position_Code__c, Related_Position__r.Name, Related_Position__r.Parent_Position__r.Client_Position_Code__c,Related_Position__r.Parent_Position__r.Name,
                                                Related_Position__r.Parent_Position__r.Parent_Position__r.Client_Position_Code__c,Related_Position__r.Parent_Position__r.Parent_Position__r.Name, 
                                                Related_Position__r.Parent_Position__r.Parent_Position__r.Parent_Position__r.Name,
                                                Related_Position__r.Parent_Position__r.Parent_Position__r.Parent_Position__r.Client_Position_Code__c,  
                                                Related_Position__r.Parent_Position__r.Parent_Position__r.Parent_Position__r.Parent_Position__r.Name,
                                                Related_Position__r.Parent_Position__r.Parent_Position__r.Parent_Position__r.Parent_Position__r.Client_Position_Code__c
                                                from Related_Position__c where Assignment_Status__c = 'Active' and Base_Position__c in : positionIds ]) {
                system.debug('#### relatedPos Id : '+relatedPos.Id);
                // Add base position as key and related position record as value
                overlayPositionsMapByBasePosition.put(relatedPos.Base_Position__c, relatedPos) ;
            }*/
            
            
            list<Related_Position__c> relatedPoslist = [Select Id, Base_Position_Team_Instance__c, Related_Position_Team_Instance__c, 
                                                Related_Position__c, Base_Position__c, Related_Position_Team_Instance__r.Team_Instance_ID__c,
                                                Related_Position_Team_Instance__r.Team_Instance_ID__r.Name,Base_Position_Team_Instance__r.Team_Instance_ID__c,
                                                /*SPD3404 CHANGE (Team_Instance__c) Name -> Team_Instance_Code__c*/
                                                Related_Position_Team_Instance__r.Team_Instance_ID__r.Team_Instance_Code__c,
                                                Related_Position_Team_Instance__r.Team_Instance_ID__r.Team__c,
                                                 /*SPD3404 CHANGE (Team_Instance__c) Name -> Team_Instance_Code__c*/
                                                Related_Position_Team_Instance__r.Team_Instance_ID__r.Team__r.Team_Code__c, 
                                                Related_Position_Team_Instance__r.Team_Instance_ID__r.Team__r.Name,
                                                Related_Position__r.Client_Position_Code__c, Related_Position__r.Name, Related_Position__r.Parent_Position__r.Client_Position_Code__c,Related_Position__r.Parent_Position__r.Name,
                                                Related_Position__r.Parent_Position__r.Parent_Position__r.Client_Position_Code__c,Related_Position__r.Parent_Position__r.Parent_Position__r.Name, 
                                                Related_Position__r.Parent_Position__r.Parent_Position__r.Parent_Position__r.Name,
                                                Related_Position__r.Parent_Position__r.Parent_Position__r.Parent_Position__r.Client_Position_Code__c,  
                                                Related_Position__r.Parent_Position__r.Parent_Position__r.Parent_Position__r.Parent_Position__r.Name,
                                                Related_Position__r.Parent_Position__r.Parent_Position__r.Parent_Position__r.Parent_Position__r.Client_Position_Code__c
                                                from Related_Position__c where Assignment_Status__c =:assignmentStatus and Base_Position__c in : positionIds ];
                                                
                                                
             for(Related_Position__c relatedPos : relatedPoslist){
             	//This if is being added for SIQ-1997 (Mirror in base otsuka requirement)
             	if(relatedPos.Related_Position_Team_Instance__r.Team_Instance_ID__c != relatedPos.Base_Position_Team_Instance__r.Team_Instance_ID__c){
	             	if(overlayPositionsMapByBasePosition.get(relatedPos.Base_Position__c) != null){
	                	list<Related_Position__c> relPosition = overlayPositionsMapByBasePosition.get(relatedPos.Base_Position__c);
	                	relPosition.add(relatedPos);
	                	overlayPositionsMapByBasePosition.put(relatedPos.Base_Position__c, relPosition);
	                }else{
	                	overlayPositionsMapByBasePosition.put(relatedPos.Base_Position__c, new list<Related_Position__c>{relatedPos});
	                }	                
	                multipleOverlayInstanceSet.add(relatedPos.Related_Position_Team_Instance__r.Team_Instance_ID__c);
             	}             
             }
            	system.debug('#### multipleOverlayInstanceSet Id : '+multipleOverlayInstanceSet);
                System.debug('EsRI overlayPositionsMapByBasePosition ---'+overlayPositionsMapByBasePosition);
                
                return overlayPositionsMapByBasePosition ;
        } 
        return null ;
    }

    /*
     * @description     Method to return the HTTPRequest wrapper to send to ESRI server for Overlay position
     * @author 			Aditi, SPD-261
     * @param           zip - Current moved zip
                        sourceOverlay - Overlay position of Change Request Source Position
                        destinationOverlay - Overlay position of Change Request Destination Position
                        isMoved - if true, it means change request is approved or created with pending status, send destination territory overlay data else source territory overlay data
     */
    public static list<RequestDataWrapper> getRequestDataWrapperForOverlay(Change_Request__c req, String zip, String status, list<Related_Position__c> sourceOverlay, list<Related_Position__c> destinationOverlay, Boolean isMoved, String userName, set<String> overlayteamInstanceSet) {
            
        list<RequestDataWrapper> reqDataForOverlayList = new list<RequestDataWrapper>(); 
        system.debug('sourceOverlay =====> '+sourceOverlay);
        system.debug('destinationOverlay =====> '+destinationOverlay);    
        if(sourceOverlay == null && destinationOverlay == null ) {
            // do nothing, no overlay position exist for source or detination
            return null ;
        } else {
        	
        	Related_Position__c sourceOverlayPos = new Related_Position__c();
        	Related_Position__c  destOverlayPos = new Related_Position__c();
        	
        	for(String overlayInstance : overlayteamInstanceSet){
        		
        		for(Related_Position__c pos : sourceOverlay){
	        		if(pos.Related_Position_Team_Instance__r.Team_Instance_ID__c == overlayInstance){
	        			sourceOverlayPos = pos;
	        		}
        		}
        		
        		for(Related_Position__c pos : destinationOverlay){
	        		if(pos.Related_Position_Team_Instance__r.Team_Instance_ID__c == overlayInstance){
	        			destOverlayPos = pos;
	        		}
        		}
        		
	            if(sourceOverlayPos != null  && destOverlayPos == null) 
	            {
	                // get the team instance name, and fetch unassigned territory for destination
	                Position__c unassignedPosition = SalesIQUtility.getUnassignedPositionByTeamName(SalesIQGlobalConstants.TEAM_TYPE_OVERLAY, sourceOverlayPos.Related_Position_Team_Instance__r.Team_Instance_ID__r.Team__c);
	
                    if(isMoved) {
                        // send destination first 
                        /*SPD3404 CHANGE (Team_Instance__c) Name -> Team_Instance_Code__c*/
                        //reqDataForOverlayList.add(new RequestDataWrapper(zip, status, unassignedPosition, sourceOverlayPos.Related_Position__r, sourceOverlayPos.Related_Position_Team_Instance__r.Team_Instance_ID__r.Name, userName, req.Change_Effective_Date__c > system.today() ? true : false, req.Request_Type_Change__c,req.Team_Instance_ID__r.Alignment_Period__c));
                        reqDataForOverlayList.add(new RequestDataWrapper(zip, status, unassignedPosition, sourceOverlayPos.Related_Position__r, sourceOverlayPos.Related_Position_Team_Instance__r.Team_Instance_ID__r.Team_Instance_Code__c, userName, req.Change_Effective_Date__c > system.today() ? true : false, req.Request_Type_Change__c,req.Team_Instance_ID__r.Alignment_Period__c));

                    } else {
                        // send source first
                        //reqDataForOverlayList.add(new RequestDataWrapper(zip, status, sourceOverlayPos.Related_Position__r, unassignedPosition, sourceOverlayPos.Related_Position_Team_Instance__r.Team_Instance_ID__r.Name, userName, req.Change_Effective_Date__c > system.today() ? true : false, req.Request_Type_Change__c,req.Team_Instance_ID__r.Alignment_Period__c));
                       /*SPD3404 CHANGE (Team_Instance__c) Name -> Team_Instance_Code__c*/
                        reqDataForOverlayList.add(new RequestDataWrapper(zip, status, sourceOverlayPos.Related_Position__r, unassignedPosition, sourceOverlayPos.Related_Position_Team_Instance__r.Team_Instance_ID__r.Team_Instance_Code__c, userName, req.Change_Effective_Date__c > system.today() ? true : false, req.Request_Type_Change__c,req.Team_Instance_ID__r.Alignment_Period__c));

                    }
	            }
	            else if(sourceOverlayPos == null && destOverlayPos != null) 
	            {
	                // get the team instance name, and fetch unassigned territory for source
	                Position__c unassignedPosition = SalesIQUtility.getUnassignedPositionByTeamName(SalesIQGlobalConstants.TEAM_TYPE_OVERLAY, destOverlayPos.Related_Position_Team_Instance__r.Team_Instance_ID__r.Team__c);
	                
	                    if(isMoved) {
	                        // send destination first
	                        //reqDataForOverlayList.add(new RequestDataWrapper(zip, status, destOverlayPos.Related_Position__r, unassignedPosition, destOverlayPos.Related_Position_Team_Instance__r.Team_Instance_ID__r.Name, userName, req.Change_Effective_Date__c > system.today() ? true : false, req.Request_Type_Change__c,req.Team_Instance_ID__r.Alignment_Period__c));
	                        /*SPD3404 CHANGE (Team_Instance__c) Name -> Team_Instance_Code__c*/
	                        reqDataForOverlayList.add(new RequestDataWrapper(zip, status, destOverlayPos.Related_Position__r, unassignedPosition, destOverlayPos.Related_Position_Team_Instance__r.Team_Instance_ID__r.Team_Instance_Code__c, userName, req.Change_Effective_Date__c > system.today() ? true : false, req.Request_Type_Change__c,req.Team_Instance_ID__r.Alignment_Period__c));
	                    } else {
	                        // send source first
	                        //reqDataForOverlayList.add(new RequestDataWrapper(zip, status, unassignedPosition, destOverlayPos.Related_Position__r, destOverlayPos.Related_Position_Team_Instance__r.Team_Instance_ID__r.Name, userName, req.Change_Effective_Date__c > system.today() ? true : false, req.Request_Type_Change__c,req.Team_Instance_ID__r.Alignment_Period__c));
	                        /*SPD3404 CHANGE (Team_Instance__c) Name -> Team_Instance_Code__c*/
	                        reqDataForOverlayList.add(new RequestDataWrapper(zip, status, unassignedPosition, destOverlayPos.Related_Position__r, destOverlayPos.Related_Position_Team_Instance__r.Team_Instance_ID__r.Team_Instance_Code__c, userName, req.Change_Effective_Date__c > system.today() ? true : false, req.Request_Type_Change__c,req.Team_Instance_ID__r.Alignment_Period__c));
	                    }
	            } 
	            else 
	            {
	                // Case : sourceOverlay != null and destinationOverlay != null, no need to find the unassigned position
	                if(isMoved) {
	                    // send destination first 
	                    System.debug( destOverlayPos);
	                    System.debug('destOverlayPos.Related_Position_Team_Instance__r.Team_Instance_ID__r.Name --'+destOverlayPos.Related_Position_Team_Instance__r.Team_Instance_ID__r.Name);
	                    System.debug('sourceOverlayPos - '+sourceOverlayPos);
	                    System.debug('userName --'+userName);
	                    System.debug('req ---'+req);
	                    
                        //reqDataForOverlayList.add(new RequestDataWrapper(zip, status, destOverlayPos.Related_Position__r, sourceOverlayPos.Related_Position__r, destOverlayPos.Related_Position_Team_Instance__r.Team_Instance_ID__r.Name, userName, req.Change_Effective_Date__c > system.today() ? true : false, req.Request_Type_Change__c,req.Team_Instance_ID__r.Alignment_Period__c));
                        /*SPD3404 CHANGE (Team_Instance__c) Name -> Team_Instance_Code__c*/
                        reqDataForOverlayList.add(new RequestDataWrapper(zip, status, destOverlayPos.Related_Position__r, sourceOverlayPos.Related_Position__r, destOverlayPos.Related_Position_Team_Instance__r.Team_Instance_ID__r.Team_Instance_Code__c, userName, req.Change_Effective_Date__c > system.today() ? true : false, req.Request_Type_Change__c,req.Team_Instance_ID__r.Alignment_Period__c));
	                } else {
	                    // send source first
                        //reqDataForOverlayList.add(new RequestDataWrapper(zip, status, sourceOverlayPos.Related_Position__r, destOverlayPos.Related_Position__r, destOverlayPos.Related_Position_Team_Instance__r.Team_Instance_ID__r.Name, userName, req.Change_Effective_Date__c > system.today() ? true : false, req.Request_Type_Change__c,req.Team_Instance_ID__r.Alignment_Period__c));
                        /*SPD3404 CHANGE (Team_Instance__c) Name -> Team_Instance_Code__c*/
                        reqDataForOverlayList.add(new RequestDataWrapper(zip, status, sourceOverlayPos.Related_Position__r, destOverlayPos.Related_Position__r, destOverlayPos.Related_Position_Team_Instance__r.Team_Instance_ID__r.Team_Instance_Code__c, userName, req.Change_Effective_Date__c > system.today() ? true : false, req.Request_Type_Change__c,req.Team_Instance_ID__r.Alignment_Period__c));
                    }
                }
            }
        }
        return reqDataForOverlayList ;  
    }
    
     /*
     * @description: method to send get callout to ESRI server to fetch the objectId for corresponding zip and team instance and parse the response
     * @param:       zipMap
     *               some param 
    */
    public static Map<String, list<RequestDataWrapper>> sendGetRequestToEsriToPopulateObjectId(String endPoint, string body, Map<String,list<RequestDataWrapper>> dataWrapperGroupByZipMap ,string requestSourcePositionCode, list<SalesIQ_Logger__c> lstLogger, string crid) {
		list<RequestDataWrapper> wrapperData = new list<requestDataWrapper>();
        try{
            system.debug('#### sendGetRequestToEsriToPopulateObjectId called');
        	Http http = new Http();
            HttpRequest httpRequest = new HttpRequest();
            httpRequest.setEndpoint(endPoint);
            httpRequest.setMethod('POST');
            httpRequest.setHeader('X-Frame-Options', 'ALLOW-FROM');
            httpRequest.setHeader('Pragma', 'no-cache');
            httpRequest.setHeader('Cache-Control', 'no-cache');
            httpRequest.setHeader('X-XSS-Protection', '1');
            httpRequest.setHeader('x-content-type-options', 'nosniff');
            httpRequest.setHeader('SET-COOKIE', 'HttpOnly');
            httpRequest.setTimeout(60000);//The default timeout is 10 seconds.The maximum cumulative timeout for callouts by a single Apex transaction is 120 seconds. 
            //This time is additive across all callouts invoked by the Apex transaction.
            httpRequest.setBody(body);

            if(!lstLogger.isEmpty()){
                lstLogger.add(SalesIQLogger.prepareSalesIQLoggerData('Establishing connection with ESRI for URL '+endPoint ,'', '' ,crid));
                lstLogger.add(SalesIQLogger.prepareSalesIQLoggerData('Preparing HTTP request for getting Object id with body '+body ,'', '' ,crid));
            }
            
            System.debug('httpRequest ---'+httpRequest);
            System.debug('body ---'+body);
            
            HTTPResponse httpResponse = new HTTPResponse();
       
            if(Test.isRunningTest()){
                ESRIServicesMockGenerator obj = new ESRIServicesMockGenerator();
                httpResponse = obj.respond(httpRequest);
            }
            else
                httpResponse = http.send(httpRequest);

            if(!lstLogger.isEmpty()){
                lstLogger.add(SalesIQLogger.prepareSalesIQLoggerData('Received status code '+httpResponse.getStatusCode()+' response from ESRI with body '+httpResponse.getBody() ,'', '',crid ));

            }

    		system.debug('#### httpResponse.getStatusCode() : '+httpResponse.getStatusCode());
            if(httpResponse.getStatusCode() == 200) {
               
                // Parse JSON response to get all the field values.            
                JSONParser parser = JSON.createParser(httpResponse.getBody());
                System.debug('httpResponse.getBody() ---'+httpResponse.getBody());
                string zipCode;
                string zip_status;
                string PositionCode;
                string PositionName;
                Integer Objectid;
                String overlayInstance;
                while (parser.nextToken() != null) {
                    if ((parser.getCurrentToken() == JSONToken.FIELD_NAME) && (parser.getText() == 'attributes')) {
                        parser.nextToken();
                        parser.nextToken();                  
                         
                        if ((parser.getCurrentToken() == JSONToken.FIELD_NAME) && (parser.getText() == 'objectid')) {
                            // Get the object id.
                            parser.nextToken();
                            Objectid = (Integer)parser.getIntegerValue();
                        }
                        parser.nextToken();                   
                        
                        if ((parser.getCurrentToken() == JSONToken.FIELD_NAME) && (parser.getText() == 'geography_name')) {
                            // Get the zip code.
                            parser.nextToken();
                            zipCode = parser.getText();
                        }
                        
                        parser.nextToken();

                            if ((parser.getCurrentToken() == JSONToken.FIELD_NAME) && (parser.getText() == 'level1_code')) {
                                // Get the zip code.
                                parser.nextToken();
                                PositionCode = parser.getText();
                            }
                            parser.nextToken();
                            if ((parser.getCurrentToken() == JSONToken.FIELD_NAME) && (parser.getText() == 'level1_name')) {
                                // Get the zip code.
                                parser.nextToken();
                                PositionName = parser.getText();
                            }
                            parser.nextToken();
                            if ((parser.getCurrentToken() == JSONToken.FIELD_NAME) && (parser.getText() == 'team_instance_name')) {
                                // Get the zip code.
                                parser.nextToken();
                                overlayInstance = parser.getText();
                            }
                             parser.nextToken();
                            if ((parser.getCurrentToken() == JSONToken.FIELD_NAME) && (parser.getText() == 'zip_status')) {
                                // Get the object id.
                                parser.nextToken();
                                zip_status =  parser.getText();
                            }
                            system.debug('#### zip code is  '+zipCode);
                            system.debug('#### Objectid  '+Objectid);
                            system.debug('#### zip_status  '+zip_status);
                            
                            system.debug('########requestSourcePositionCode' + requestSourcePositionCode);
                            
                            system.debug('#######positionCode'+positionCode);
                            system.debug('#########overlayInstance'+overlayInstance);
                            wrapperData = dataWrapperGroupByZipMap.get(zipCode);
                            for(RequestDataWrapper wrapper : wrapperData){
                                //SPD-3416 Arun
                                system.debug('#### wrapper crType ' + wrapper.crType);
                                if(wrapper.crType=='ZIP Sharing'){
                                    if(wrapper.team_instance_name == overlayInstance && wrapper.zip==zipCode && wrapper.level1_code==PositionCode ){
                                        wrapper.objectid = Objectid;
                                        //dataWrapperGroupByZipMap.get(zipCode).objectid = Objectid;
                                    }

                            }else if(wrapper.crType==SalesIQGlobalConstants.MOVEMENT_TYPE_ZIP){
                                
                                system.debug('#####wrapper.team_instance_name'+wrapper.team_instance_name);
                                if(requestSourcePositionCode!=''){
                                    
                                    if(zip_status=='SUBMISSION_PENDING' && wrapper.zip==zipCode && wrapper.team_instance_name == overlayInstance){
                                        wrapper.objectid = Objectid;
                                    }
                                    
                                    if(wrapper.team_instance_name == overlayInstance && wrapper.zip==zipCode && positionCode==requestSourcePositionCode){
                                        System.debug('######in this condition');
                                        wrapper.objectid = Objectid;                                
                                    }
                                }else{
                                    if(wrapper.team_instance_name == overlayInstance){
                                        wrapper.objectid = Objectid;                                
                                    }
                                }
                            }
                            else if(wrapper.crType ==SalesIQGlobalConstants.REQUEST_STATUS_SUBMISSION_PENDING || wrapper.crType ==SalesIQGlobalConstants.REQUEST_STATUS_DELETE_SUBMISSION_PENDING){
                                system.debug('in SP ');
                                //in case of Submission we don't need to compare Level1 position code, becasue in ESRI we have different position and in SFDC we have diffreern position(proposed position)
                                if(wrapper.team_instance_name == overlayInstance && wrapper.zip==zipCode){
                                    system.debug('wrapper.zip '+wrapper.zip);
                                    wrapper.objectid = Objectid;                                    
                                }

                            }

                            else{
                                if(wrapper.team_instance_name == overlayInstance){
                                    wrapper.objectid = Objectid;                                
                                }

                            }
                            
                        }
                    }
                    if ((parser.getCurrentToken() == JSONToken.FIELD_NAME) && (parser.getText() == 'error')) {
                    	parser.nextToken(); parser.nextToken(); parser.nextToken(); parser.nextToken(); parser.nextToken();
                    	system.debug('#### Something went wrong : '+parser.getText());
                        if(!lstLogger.isEmpty()){
                            lstLogger.add(SalesIQLogger.prepareSalesIQLoggerData('Error '+parser.getText() ,'', '',crid ));
                        }
                    }
                }
    			
                
            }else{
            	system.debug('#### Something went wrong : '+httpResponse.getStatusCode());
            }

        }
        catch(Exception ex){
            if(!lstLogger.isEmpty()){
                lstLogger.add(SalesIQLogger.prepareSalesIQLoggerData('Error '+ex.getStackTraceString() ,ex.getMessage(), '',crid ));
            }
            //system.debug('sendGetRequestToEsriToPopulateObjectId '+ex.getStackTraceString());
            throw new InsufficentPriviligesException('Error in sendGetRequestToEsriToPopulateObjectId '+ex.getStackTraceString());  
                
        }    
        return dataWrapperGroupByZipMap ;
    }


    /* Start create new method after getting Astalles ESRI issue */

     /*
     * @description: method to send get callout to ESRI server to fetch the objectId for corresponding zip and team instance and parse the response
     * @param:       zipMap
     *               some param 
    */
    public static Map<String, list<RequestDataWrapper>> sendGetRequestToEsriToPopulateObjectId(String endPoint, string body, Map<String,list<RequestDataWrapper>> dataWrapperGroupByZipMap ,string requestSourcePositionCode, list<SalesIQ_Logger__c> lstLogger, string crid, string requestDestinationPositionCode) {
        list<RequestDataWrapper> wrapperData = new list<requestDataWrapper>();
        try{
            system.debug('#### New sendGetRequestToEsriToPopulateObjectId called');
            Http http = new Http();
            HttpRequest httpRequest = new HttpRequest();
            httpRequest.setEndpoint(endPoint);
            httpRequest.setMethod('POST');
            httpRequest.setHeader('X-Frame-Options', 'ALLOW-FROM');
            httpRequest.setHeader('Pragma', 'no-cache');
            httpRequest.setHeader('Cache-Control', 'no-cache');
            httpRequest.setHeader('X-XSS-Protection', '1');
            httpRequest.setHeader('x-content-type-options', 'nosniff');
            httpRequest.setHeader('SET-COOKIE', 'HttpOnly');
            httpRequest.setTimeout(60000);//The default timeout is 10 seconds.The maximum cumulative timeout for callouts by a single Apex transaction is 120 seconds. 
            //This time is additive across all callouts invoked by the Apex transaction.
            httpRequest.setBody(body);

            if(!lstLogger.isEmpty()){
                lstLogger.add(SalesIQLogger.prepareSalesIQLoggerData('Establishing connection with ESRI for URL '+endPoint ,'', '' ,crid));
                lstLogger.add(SalesIQLogger.prepareSalesIQLoggerData('Preparing HTTP request for getting Object id with body '+body ,'', '' ,crid));
            }
            
            System.debug('httpRequest ---'+httpRequest);
            System.debug('body ---'+body);
            
            HTTPResponse httpResponse = new HTTPResponse();
       
            if(Test.isRunningTest()){
                ESRIServicesMockGenerator obj = new ESRIServicesMockGenerator();
                httpResponse = obj.respond(httpRequest);
            }
            else
                httpResponse = http.send(httpRequest);

            if(!lstLogger.isEmpty()){
                lstLogger.add(SalesIQLogger.prepareSalesIQLoggerData('Received status code '+httpResponse.getStatusCode()+' response from ESRI with body '+httpResponse.getBody() ,'', '',crid ));

            }

            system.debug('#### httpResponse.getStatusCode() : '+httpResponse.getStatusCode());
            if(httpResponse.getStatusCode() == 200) {
               
                // Parse JSON response to get all the field values.            
                JSONParser parser = JSON.createParser(httpResponse.getBody());
                System.debug('httpResponse.getBody() ---'+httpResponse.getBody());
                string zipCode;
                string zip_status;
                string PositionCode;
                string PositionName;
                Integer Objectid;
                String overlayInstance;
                while (parser.nextToken() != null) {
                    if ((parser.getCurrentToken() == JSONToken.FIELD_NAME) && (parser.getText() == 'attributes')) {
                        parser.nextToken();
                        parser.nextToken();                  
                         
                        if ((parser.getCurrentToken() == JSONToken.FIELD_NAME) && (parser.getText() == 'objectid')) {
                            // Get the object id.
                            parser.nextToken();
                            Objectid = (Integer)parser.getIntegerValue();
                        }
                        parser.nextToken();                   
                        
                        if ((parser.getCurrentToken() == JSONToken.FIELD_NAME) && (parser.getText() == 'geography_name')) {
                            // Get the zip code.
                            parser.nextToken();
                            zipCode = parser.getText();
                        }
                        
                        parser.nextToken();

                            if ((parser.getCurrentToken() == JSONToken.FIELD_NAME) && (parser.getText() == 'level1_code')) {
                                // Get the zip code.
                                parser.nextToken();
                                PositionCode = parser.getText();
                            }
                            parser.nextToken();
                            if ((parser.getCurrentToken() == JSONToken.FIELD_NAME) && (parser.getText() == 'level1_name')) {
                                // Get the zip code.
                                parser.nextToken();
                                PositionName = parser.getText();
                            }
                            parser.nextToken();
                            if ((parser.getCurrentToken() == JSONToken.FIELD_NAME) && (parser.getText() == 'team_instance_name')) {
                                // Get the zip code.
                                parser.nextToken();
                                overlayInstance = parser.getText();
                            }
                             parser.nextToken();
                            if ((parser.getCurrentToken() == JSONToken.FIELD_NAME) && (parser.getText() == 'zip_status')) {
                                // Get the object id.
                                parser.nextToken();
                                zip_status =  parser.getText();
                            }
                            system.debug('#### zip code is  '+zipCode);
                            system.debug('#### Objectid  '+Objectid);
                            system.debug('#### zip_status  '+zip_status);
                            
                            system.debug('########requestSourcePositionCode' + requestSourcePositionCode);
                            
                            system.debug('#######positionCode'+positionCode);
                            system.debug('#########overlayInstance'+overlayInstance);
                            wrapperData = dataWrapperGroupByZipMap.get(zipCode);
                            for(RequestDataWrapper wrapper : wrapperData){
                                //SPD-3416 Arun
                                system.debug('#### wrapper crType ' + wrapper.crType);
                                if(wrapper.crType=='ZIP Sharing'){
                                    if(wrapper.team_instance_name == overlayInstance && wrapper.zip==zipCode && wrapper.level1_code==PositionCode ){
                                        wrapper.objectid = Objectid;
                                        //dataWrapperGroupByZipMap.get(zipCode).objectid = Objectid;
                                    }

                            }else if(wrapper.crType==SalesIQGlobalConstants.MOVEMENT_TYPE_ZIP){
                                
                                system.debug('#####wrapper.team_instance_name'+wrapper.team_instance_name);
                                if(wrapper.status==SalesIQGlobalConstants.REQUEST_STATUS_PENDING || wrapper.status==SalesIQGlobalConstants.REQUEST_STATUS_APPROVED){
                                    if(zip_status==SalesIQGlobalConstants.ESRI_ZIPSTATUS_SUBMISSION_PENDING || zip_status==SalesIQGlobalConstants.ESRI_ZIPSTATUS_LOCKED){
                                        System.debug('######in SUBMISSION_PENDING && LOCKED condition');
                                        if(wrapper.team_instance_name == overlayInstance && wrapper.zip==zipCode && positionCode==requestDestinationPositionCode){
                                            
                                            wrapper.objectid = Objectid;                                
                                        }

                                    }else if(zip_status==SalesIQGlobalConstants.ESRI_ZIPSTATUS_UNLOCKED){
                                        System.debug('######in UNLOCKED condition');
                                        if(wrapper.team_instance_name == overlayInstance && wrapper.zip==zipCode && positionCode==requestSourcePositionCode){
                                            
                                            wrapper.objectid = Objectid;                                
                                        }

                                    }

                                }else{
                                    if(requestSourcePositionCode!=''){
                                        
                                        if(zip_status=='SUBMISSION_PENDING' && wrapper.zip==zipCode && wrapper.team_instance_name == overlayInstance){
                                            wrapper.objectid = Objectid;
                                        }
                                        
                                        if(wrapper.team_instance_name == overlayInstance && wrapper.zip==zipCode && positionCode==requestSourcePositionCode){
                                            System.debug('######in this condition');
                                            wrapper.objectid = Objectid;                                
                                        }
                                    }else{
                                        if(wrapper.team_instance_name == overlayInstance){
                                            wrapper.objectid = Objectid;                                
                                        }
                                    }
                                }
                            }
                            else if(wrapper.crType ==SalesIQGlobalConstants.REQUEST_STATUS_SUBMISSION_PENDING || wrapper.crType ==SalesIQGlobalConstants.REQUEST_STATUS_DELETE_SUBMISSION_PENDING){
                                system.debug('in SP ');
                                //in case of Submission we don't need to compare Level1 position code, becasue in ESRI we have different position and in SFDC we have diffreern position(proposed position)
                                if(wrapper.team_instance_name == overlayInstance && wrapper.zip==zipCode){
                                    system.debug('wrapper.zip '+wrapper.zip);
                                    wrapper.objectid = Objectid;                                    
                                }

                            }

                            else{
                                if(wrapper.team_instance_name == overlayInstance){
                                    wrapper.objectid = Objectid;                                
                                }

                            }
                            
                        }
                    }
                    if ((parser.getCurrentToken() == JSONToken.FIELD_NAME) && (parser.getText() == 'error')) {
                        parser.nextToken(); parser.nextToken(); parser.nextToken(); parser.nextToken(); parser.nextToken();
                        system.debug('#### Something went wrong : '+parser.getText());
                        if(!lstLogger.isEmpty()){
                            lstLogger.add(SalesIQLogger.prepareSalesIQLoggerData('Error '+parser.getText() ,'', '',crid ));
                        }
                    }
                }
                
                
            }else{
                system.debug('#### Something went wrong : '+httpResponse.getStatusCode());
            }

        }
        catch(Exception ex){
            if(!lstLogger.isEmpty()){
                lstLogger.add(SalesIQLogger.prepareSalesIQLoggerData('Error '+ex.getStackTraceString() ,ex.getMessage(), '',crid ));
            }
            //system.debug('sendGetRequestToEsriToPopulateObjectId '+ex.getStackTraceString());
            throw new InsufficentPriviligesException('Error in sendGetRequestToEsriToPopulateObjectId '+ex.getStackTraceString());  
                
        }    
        return dataWrapperGroupByZipMap ;
    }


    /* End */
    

    /*
     * @description: method to send get callout to ESRI server to fetch the objectId for corresponding zip and team instance and parse the response
     This method is also gets called when CR tracking Off
     * @param:       zipMap
     *               some param 
    */
    public static Map<String, list<RequestDataWrapper>> sendGetRequestToEsriToPopulateObjectId(String endPoint, string body, Map<String,list<RequestDataWrapper>> dataWrapperGroupByZipMap, list<SalesIQ_Logger__c> lstLogger, string crid) {
		list<RequestDataWrapper> wrapperData = new list<requestDataWrapper>();
        //list<SalesIQ_Logger__c> lstLogger = new list<SalesIQ_Logger__c>();
        try{
            system.debug('#### sendGetRequestToEsriToPopulateObjectId called');

            
        	Http http = new Http();
            HttpRequest httpRequest = new HttpRequest();
            httpRequest.setEndpoint(endPoint);
            httpRequest.setMethod('POST');
            httpRequest.setHeader('X-Frame-Options', 'ALLOW-FROM');
            httpRequest.setHeader('Pragma', 'no-cache');
            httpRequest.setHeader('Cache-Control', 'no-cache');
            httpRequest.setHeader('X-XSS-Protection', '1');
            httpRequest.setHeader('x-content-type-options', 'nosniff');
            httpRequest.setHeader('SET-COOKIE', 'HttpOnly');
            httpRequest.setTimeout(60000);//The default timeout is 10 seconds.The maximum cumulative timeout for callouts by a single Apex transaction is 120 seconds. 
            //This time is additive across all callouts invoked by the Apex transaction.
            httpRequest.setBody(body);

            if(!lstLogger.isEmpty()){
                lstLogger.add(SalesIQLogger.prepareSalesIQLoggerData('Preparing HTTP request for getting Object id with body '+body ,'', '' ,crid));
            }
            
            System.debug('httpRequest ---'+httpRequest);
            System.debug('body sendGetRequestToEsriToPopulateObjectId ---'+body);
            
            HTTPResponse httpResponse = new HTTPResponse();
           
            if(Test.isRunningTest()){
                ESRIServicesMockGenerator obj = new ESRIServicesMockGenerator();
                httpResponse = obj.respond(httpRequest);
            }
            else
                httpResponse = http.send(httpRequest);

            if(!lstLogger.isEmpty()){
                lstLogger.add(SalesIQLogger.prepareSalesIQLoggerData('Received status code '+httpResponse.getStatusCode()+' response from ESRI with body '+httpResponse.getBody() ,'', '',crid ));

            }
            
    		system.debug('#### httpResponse.getStatusCode() : '+httpResponse.getStatusCode());
            if(httpResponse.getStatusCode() == 200) {
               
                // Parse JSON response to get all the field values.            
                JSONParser parser = JSON.createParser(httpResponse.getBody());
                System.debug('httpResponse.getBody() ---'+httpResponse.getBody());

                string zipCode;
                string PositionCode;
                string PositionName;
                Integer Objectid;
                String overlayInstance;
                //lstLogger.add(SalesIQLogger.prepareSalesIQLoggerData('Start parsing of Respose from ESRI server','', '' ));

                while (parser.nextToken() != null) {
                    if ((parser.getCurrentToken() == JSONToken.FIELD_NAME) && (parser.getText() == 'attributes')) {
                        parser.nextToken();
                        parser.nextToken();     
                        system.debug('parser.getText() '+parser.getText());             
                         
                        if ((parser.getCurrentToken() == JSONToken.FIELD_NAME) && (parser.getText() == 'objectid')) {
                            // Get the object id.
                               
                            parser.nextToken();
                            Objectid = (Integer)parser.getIntegerValue();
                        }
                        parser.nextToken();                   
                        
                        if ((parser.getCurrentToken() == JSONToken.FIELD_NAME) && (parser.getText() == 'geography_name')) {
                            // Get the zip code.
                            parser.nextToken();
                            zipCode = parser.getText();
                        }
                        
                        parser.nextToken();

                            if ((parser.getCurrentToken() == JSONToken.FIELD_NAME) && (parser.getText() == 'level1_code')) {
                                // Get the zip code.
                                parser.nextToken();
                                PositionCode = parser.getText();
                            }
                            parser.nextToken();
                            if ((parser.getCurrentToken() == JSONToken.FIELD_NAME) && (parser.getText() == 'level1_name')) {
                                // Get the zip code.
                                parser.nextToken();
                                PositionName = parser.getText();
                            }
                            parser.nextToken();
                            if ((parser.getCurrentToken() == JSONToken.FIELD_NAME) && (parser.getText() == 'team_instance_name')) {
                                // Get the zip code.
                                parser.nextToken();
                                overlayInstance = parser.getText();
                            }
                            system.debug('#### zip code is  '+zipCode);
                            system.debug('#### Objectid  '+Objectid);
                            system.debug('#### PositionCode  '+PositionCode);
                            system.debug('#### overlayInstance  '+overlayInstance);
                            
                            wrapperData = dataWrapperGroupByZipMap.get(zipCode);
                            system.debug('#### wrapperData  '+wrapperData);

                            for(RequestDataWrapper wrapper : wrapperData){
                                //SPD-3416 Arun
                                
                                if(wrapper.crType=='ZIP Sharing'){
                                    if(wrapper.team_instance_name == overlayInstance && wrapper.zip==zipCode && wrapper.level1_code==PositionCode ){
                                        wrapper.objectid = Objectid;
                                        //dataWrapperGroupByZipMap.get(zipCode).objectid = Objectid;
                                    }

                            }
                            else if(wrapper.crType ==SalesIQGlobalConstants.REQUEST_STATUS_SUBMISSION_PENDING || wrapper.crType ==SalesIQGlobalConstants.REQUEST_STATUS_DELETE_SUBMISSION_PENDING){
                                system.debug('in SP ');
                                //in case of Submission we don't need to compare Level1 position code, becasue in ESRI we have different position and in SFDC we have diffreern position(proposed position)
                                if(wrapper.team_instance_name == overlayInstance && wrapper.zip==zipCode){
                                    system.debug('wrapper.zip '+wrapper.zip);
                                    wrapper.objectid = Objectid;                                    
                                }

                            }

                            else{
                                if(wrapper.team_instance_name == overlayInstance){
                                    wrapper.objectid = Objectid;                                
                                }

                            }
                            
                        }
                    }
                    if ((parser.getCurrentToken() == JSONToken.FIELD_NAME) && (parser.getText() == 'error')) {
                    	parser.nextToken(); parser.nextToken(); parser.nextToken(); parser.nextToken(); parser.nextToken();
                    	system.debug('#### Something went wrong : '+parser.getText());
                        if(!lstLogger.isEmpty()){
                            lstLogger.add(SalesIQLogger.prepareSalesIQLoggerData('Error '+parser.getText() ,'', '',crid ));
                        }
                        
                    }
                }
    			
                
            }else{
            	system.debug('#### Something went wrong : '+httpResponse.getStatusCode());
            }

        
        } catch(exception ex) {
            system.debug('Error in '+ex.getMessage());
            if(!lstLogger.isEmpty()){
                lstLogger.add(SalesIQLogger.prepareSalesIQLoggerData('Error '+ex.getStackTraceString() ,ex.getMessage(), '',crid ));
            }
            system.debug('sendGetRequestToEsriToPopulateObjectId '+ex.getStackTraceString());
            throw new InsufficentPriviligesException('Error in sendGetRequestToEsriToPopulateObjectId '+ex.getStackTraceString());   
        }
        finally{
            //insert lstLogger;
        }
        return dataWrapperGroupByZipMap ;
    }



    /*@author : Arun Kumar
    @date : 4 Aug 2017  
    @description : This method will be called when user finally Post the data to ESRI.
    I have added two new parameter, so that same method can be used for inserting the new Record as well as update the existing record at ESRI
    @param1: list of Position geography
    @return : Void
    */
    public static void sendPostRequestToEsriToUpdateData(Map<String, list<RequestDataWrapper>> zipDataMap, string sESRIOperationType, string sharingOperationType) {
        MapServerURL__c ESRIService = MapServerURL__c.getOrgDefaults();
        
        HttpRequest postReq = new HttpRequest();
        try{

            postReq.setEndpoint(ESRIService.Service_URL__c+ESRIService.Territory_Layer__c +sESRIOperationType);            
            postReq.setMethod('POST');
            postReq.setHeader('X-Frame-Options', 'ALLOW-FROM');
            postReq.setHeader('Pragma', 'no-cache');
            postReq.setHeader('Cache-Control', 'no-cache');
            postReq.setHeader('X-XSS-Protection', '1');
            postReq.setHeader('x-content-type-options', 'nosniff');
            postReq.setHeader('SET-COOKIE', 'HttpOnly');
            postReq.setTimeout(60000);//The default timeout is 10 seconds.The maximum cumulative timeout for callouts by a single Apex transaction is 120 seconds. 
            //This time is additive across all callouts invoked by the Apex transaction.
            
            string paramValue = '[';
            for(string zip : zipDataMap.keyset()){
            	list<RequestDataWrapper> requestWrapperList = new list<RequestDataWrapper>();
            	requestWrapperList = zipDataMap.get(zip);
    	        for(RequestDataWrapper request : requestWrapperList){
    	            System.debug('post request ----'+request);
    	            if(request.objectid != null){
    	                paramValue += '{\'attributes\':{';
    	                paramValue += '\'objectid\':'+request.objectid+',';
    	                if(request.status == SalesIQGlobalConstants.REQUEST_STATUS_PENDING)
    	                    paramValue += '\'zip_status\':\'LOCKED\',';
    	                else if(request.isFuture && request.crType == SalesIQGlobalConstants.MOVEMENT_TYPE_ZIP && request.alignmentPeriod == SalesIQGlobalConstants.CURRENT_TEAM_CYCLE_TYPE){
    	                    paramValue += '\'zip_status\':\'FUTURE_UNLOCKED\',';
                        }else if(request.status == SalesIQGlobalConstants.ESRI_SHARED_STATUS){
                            paramValue += '\'zip_status\':\'SHARED\',';
                        }else if(request.crType == SalesIQGlobalConstants.REQUEST_STATUS_SUBMISSION_PENDING){
                            paramValue += '\'zip_status\':\'SUBMISSION_PENDING\',';
                        }
                        else{
                            //below case will also execute in case of Delete Submission Pending request. 
                            //Becasue in that case we need to unlock those ZIPs again and for that we need UNLOCKED status
                            paramValue += '\'zip_status\':\'UNLOCKED\',';
                        }
    	
    	                paramValue += '\'level1_code\':\''+request.level1_code+'\',';
    	                paramValue += '\'level1_name\':\''+request.level1_name+'\',';
    	                paramValue += '\'level2_code\':\''+request.level2_code+'\',';
    	                paramValue += '\'level2_name\':\''+request.level2_name+'\',';
    	                paramValue += '\'level3_code\':\''+request.level3_code+'\',';
    	                paramValue += '\'level3_name\':\''+request.level3_name+'\',';
    	                paramValue += '\'level4_code\':\''+request.level4_code+'\',';
    	                paramValue += '\'level4_name\':\''+request.level4_name+'\',';
    	                paramValue += '\'level5_code\':\''+request.level5_code+'\',';
    	                paramValue += '\'level5_name\':\''+request.level5_name+'\',';
                            paramValue += '\'last_edited_sfdc_user\':\''+request.last_edited_sfdc_user+'\',';

                        
    	                paramValue += '}},';
    	            }
    	        }
            }
            paramValue = paramValue.removeEnd(',');
            paramValue += ']';
            
            System.debug('#############paramValue');
            System.debug(paramValue);
            //lstLogger.add(SalesIQLogger.prepareSalesIQLoggerData('Prepared JSON string for updating ESRI '+paramValue ,'', '' ));

            
            String body = 'features='+paramValue+'&f=json';
                        
            postReq.setBody(body);
            Http postHttp = new Http();

            HTTPResponse postRes = new HttpResponse();
            if(Test.isRunningTest()){
                ESRIServicesMockGenerator obj = new ESRIServicesMockGenerator();
                postRes = obj.respond(postReq);
            }
            else
                postRes = postHttp.send(postReq);

           
            if(postRes.getStatusCode() == 200){
                system.debug('Post request Passed.');
                //lstLogger.add(SalesIQLogger.prepareSalesIQLoggerData('ESRI updated successfully with '+postRes.getBody() ,'', '' ));

            }else{
                system.debug('Oops something went wrong in post request');
            }
        }catch(exception ex){
            //lstLogger.add(SalesIQLogger.prepareSalesIQLoggerData('Error: '+ex.getMessage()+' in sendPostRequestToEsriToUpdateData method of SyncWithESRIBatch' ,'', '' ));
            system.debug('Error in  '+ex.getStackTraceString());
            system.debug('Error in  '+ex.getMessage());
            throw new InsufficentPriviligesException('Error in sendPostRequestToEsriToUpdateData '+ex.getStackTraceString());     
        }
        
    }



    /*@author : Arun Kumar
    @date : 18 Jan 2019  
    @description : This method will be called when user finally Post the data to ESRI. This is replica of another method with logging enabled
    I have added two new parameter, with salesiqlogger and CR id
    @param1: list of Position geography
    @return : Void
    */
    public static void sendPostRequestToEsriToUpdateData(Map<String, list<RequestDataWrapper>> zipDataMap, string sESRIOperationType, string sharingOperationType, list<SalesIQ_Logger__c> lstLogger, string crid) {
        system.debug('sendPostRequestToEsriToUpdateData with logging enabled ');
        MapServerURL__c ESRIService = MapServerURL__c.getOrgDefaults();
        
        HttpRequest postReq = new HttpRequest();
        try{

            postReq.setEndpoint(ESRIService.Service_URL__c+ESRIService.Territory_Layer__c +sESRIOperationType);            
            postReq.setMethod('POST');
            postReq.setHeader('X-Frame-Options', 'ALLOW-FROM');
            postReq.setHeader('Pragma', 'no-cache');
            postReq.setHeader('Cache-Control', 'no-cache');
            postReq.setHeader('X-XSS-Protection', '1');
            postReq.setHeader('x-content-type-options', 'nosniff');
            postReq.setHeader('SET-COOKIE', 'HttpOnly');
            postReq.setTimeout(60000);//The default timeout is 10 seconds.The maximum cumulative timeout for callouts by a single Apex transaction is 120 seconds. 
            //This time is additive across all callouts invoked by the Apex transaction.
            
            string paramValue = '[';
            for(string zip : zipDataMap.keyset()){
                list<RequestDataWrapper> requestWrapperList = new list<RequestDataWrapper>();
                requestWrapperList = zipDataMap.get(zip);
                for(RequestDataWrapper request : requestWrapperList){
                    System.debug('post request ----'+request);
                    if(request.objectid != null){
                        paramValue += '{\'attributes\':{';
                        paramValue += '\'objectid\':'+request.objectid+',';
                        if(request.status == SalesIQGlobalConstants.REQUEST_STATUS_PENDING)
                            paramValue += '\'zip_status\':\'LOCKED\',';
                        else if(request.isFuture && request.crType == SalesIQGlobalConstants.MOVEMENT_TYPE_ZIP && request.alignmentPeriod == SalesIQGlobalConstants.CURRENT_TEAM_CYCLE_TYPE){
                            paramValue += '\'zip_status\':\'FUTURE_UNLOCKED\',';
                        }else if(request.status == SalesIQGlobalConstants.ESRI_SHARED_STATUS){
                            paramValue += '\'zip_status\':\'SHARED\',';
                        }else if(request.crType == SalesIQGlobalConstants.REQUEST_STATUS_SUBMISSION_PENDING){
                            paramValue += '\'zip_status\':\'SUBMISSION_PENDING\',';
                        }
                        else{
                            //below case will also execute in case of Delete Submission Pending request. 
                            //Becasue in that case we need to unlock those ZIPs again and for that we need UNLOCKED status
                            paramValue += '\'zip_status\':\'UNLOCKED\',';
                        }
        
                        paramValue += '\'level1_code\':\''+request.level1_code+'\',';
                        paramValue += '\'level1_name\':\''+request.level1_name+'\',';
                        paramValue += '\'level2_code\':\''+request.level2_code+'\',';
                        paramValue += '\'level2_name\':\''+request.level2_name+'\',';
                        paramValue += '\'level3_code\':\''+request.level3_code+'\',';
                        paramValue += '\'level3_name\':\''+request.level3_name+'\',';
                        paramValue += '\'level4_code\':\''+request.level4_code+'\',';
                        paramValue += '\'level4_name\':\''+request.level4_name+'\',';
                        paramValue += '\'level5_code\':\''+request.level5_code+'\',';
                        paramValue += '\'level5_name\':\''+request.level5_name+'\',';
                            paramValue += '\'last_edited_sfdc_user\':\''+request.last_edited_sfdc_user+'\',';

                        
                        paramValue += '}},';
                    }
                }
            }
            paramValue = paramValue.removeEnd(',');
            paramValue += ']';
            
            System.debug('#############paramValue');
            System.debug(paramValue);
            //lstLogger.add(SalesIQLogger.prepareSalesIQLoggerData('Prepared JSON string for updating ESRI '+paramValue ,'', '' ));

            if(!paramValue.contains('[]')){
                System.debug('Pass esri sync');

                String body = 'features='+paramValue+'&f=json';
                if(!lstLogger.isEmpty()){
                    lstLogger.add(SalesIQLogger.prepareSalesIQLoggerData('Prepared JSON string for updating ESRI with body '+body ,'', '',crId ));

                }               
                
                postReq.setBody(body);
                Http postHttp = new Http();

                HTTPResponse postRes = new HttpResponse();
                if(Test.isRunningTest()){
                    ESRIServicesMockGenerator obj = new ESRIServicesMockGenerator();
                    postRes = obj.respond(postReq);
                }
                else
                    postRes = postHttp.send(postReq);


                system.debug('postRes.getBody() '+postRes.getBody());

                
                if(!lstLogger.isEmpty()){
                    lstLogger.add(SalesIQLogger.prepareSalesIQLoggerData('Received status code '+postRes.getStatusCode()+' response from ESRI with body '+postRes.getBody() ,'', '' ,crId));

                }
                
                //lstLogger.add(SalesIQLogger.prepareSalesIQLoggerData('Received status code '+postRes.getStatusCode()+' response from ESRI with body '+postRes.getBody() ,'', '' ));

                if(postRes.getStatusCode() == 200){
                    system.debug('Post request Passed.');
                    //lstLogger.add(SalesIQLogger.prepareSalesIQLoggerData('ESRI updated successfully with '+postRes.getBody() ,'', '' ));

                }else{
                    system.debug('Oops something went wrong in post request');
                }
            }else{
                if(!lstLogger.isEmpty()){
                    lstLogger.add(SalesIQLogger.prepareSalesIQLoggerData('Not able to find object id from ESRI response. Hance payload is '+paramValue ,'', '' ,crId));

                }
                throw new InsufficentPriviligesException('Error in sendPostRequestToEsriToUpdateData ');  

            }
        }catch(exception ex){
            //lstLogger.add(SalesIQLogger.prepareSalesIQLoggerData('Error: '+ex.getMessage()+' in sendPostRequestToEsriToUpdateData method of SyncWithESRIBatch' ,'', '' ));
            system.debug('Error in  '+ex.getStackTraceString());
            system.debug('Error in  '+ex.getMessage());
            throw new InsufficentPriviligesException('Error in sendPostRequestToEsriToUpdateData '+ex.getStackTraceString());     
        }
        finally{
            //insert lstLogger;

        }
    }


    /*@author : Arun Kumar
    @date : 10 Aug 2017  
    @description : This method will be called when user finally Post the data to ESRI for Inserting.
    
    @param1: list of Position geography
    @return : Void
    */
    public static void sendPostRequestToEsriToInsertData(Map<String, list<RequestDataWrapper>> zipDataMap, string sESRIOperationType, string sharingOperationType) {
        MapServerURL__c ESRIService = MapServerURL__c.getOrgDefaults();
        //string strESRIOperationType = 'updateFeatures';
        string operationType = 'Add';

        HttpRequest postReq = new HttpRequest();
        postReq.setEndpoint(ESRIService.Service_URL__c+ESRIService.Territory_Layer__c +sESRIOperationType);            
        postReq.setMethod('POST');
        postReq.setHeader('X-Frame-Options', 'ALLOW-FROM');
        postReq.setHeader('Pragma', 'no-cache');
        postReq.setHeader('Cache-Control', 'no-cache');
        postReq.setHeader('X-XSS-Protection', '1');
        postReq.setHeader('x-content-type-options', 'nosniff');
        postReq.setHeader('SET-COOKIE', 'HttpOnly');
        postReq.setTimeout(60000);//The default timeout is 10 seconds.The maximum cumulative timeout for callouts by a single Apex transaction is 120 seconds. 
        //This time is additive across all callouts invoked by the Apex transaction.
        
        string paramValue = '[';
        for(string zip : zipDataMap.keyset()){
            list<RequestDataWrapper> requestWrapperList = new list<RequestDataWrapper>();
            requestWrapperList = zipDataMap.get(zip);
            for(RequestDataWrapper request : requestWrapperList){
                System.debug('post request ----'+request);               
                    paramValue += '{\'attributes\':{';
                    paramValue += '\'geography_name\':\''+request.zip+'\',';    
                    paramValue += '\'team_instance_name\':\''+request.team_instance_name+'\',';   
                    paramValue += '\'team_type\':\''+request.team_type+'\',';                
                    paramValue += '\'team_name\':\''+request.team_name+'\',';   
                    if(request.crType == SalesIQGlobalConstants.MOVEMENT_TYPE_ZIP_SHARING){
                        paramValue += '\'zip_status\':\'SHARED\',';
                    }else{
                         paramValue += '\'zip_status\':\'UNLOCKED\',';
                    }
    
                    paramValue += '\'level1_code\':\''+request.level1_code+'\',';
                    paramValue += '\'level1_name\':\''+request.level1_name+'\',';
                    paramValue += '\'level2_code\':\''+request.level2_code+'\',';
                    paramValue += '\'level2_name\':\''+request.level2_name+'\',';
                    paramValue += '\'level3_code\':\''+request.level3_code+'\',';
                    paramValue += '\'level3_name\':\''+request.level3_name+'\',';
                    paramValue += '\'level4_code\':\''+request.level4_code+'\',';
                    paramValue += '\'level4_name\':\''+request.level4_name+'\',';
                    paramValue += '\'level5_code\':\''+request.level5_code+'\',';
                    paramValue += '\'level5_name\':\''+request.level5_name+'\',';
                    paramValue += '\'last_edited_sfdc_user\':\''+request.last_edited_sfdc_user+'\',';

                    
                    paramValue += '}},';
                
            }
        }
        paramValue = paramValue.removeEnd(',');
        paramValue += ']';
        system.debug('paramValue inser '+paramValue);
        
        String body = 'features='+paramValue+'&f=json';

        system.debug('body .'+body);
       
        
        postReq.setBody(body);
        Http postHttp = new Http();
        system.debug('postReq .'+postReq);

        HTTPResponse postRes = new HttpResponse();
        if(Test.isRunningTest()){
            ESRIServicesMockGenerator obj = new ESRIServicesMockGenerator();
            postRes = obj.respond(postReq);
        }
        else
            postRes = postHttp.send(postReq);
        
      
        if(postRes.getStatusCode() == 200){
            system.debug('Post request Passed.');
        }else{
            system.debug('Oops something went wrong in post request');
        }
    }
    
    /*@author : Gaurav
    @date : 29 Aug 2017  
    @description : This method will delete the records on ESRI end and once connection is set up delete on salesforce end will be done in this method only.
    @param1: Map of geography name and Request Data wrapper
    @param2: string = delete features(to be added in Post request)
    @param3: list of PosGeo records to be deleted in salesforce.
    @return : Void
    */
     public static void  sendPostRequestToEsriToDeleteData(Map<String, list<RequestDataWrapper>> zipDataMap, string requestTypeURL , list<Position_Geography__c> toBeDeletedPosGeo){
     	MapServerURL__c ESRIService = MapServerURL__c.getOrgDefaults();
        HttpRequest postReq = new HttpRequest();
        postReq.setEndpoint(ESRIService.Service_URL__c+ESRIService.Territory_Layer__c +requestTypeURL);            
        postReq.setMethod('POST');
        postReq.setHeader('X-Frame-Options', 'ALLOW-FROM');
        postReq.setHeader('Pragma', 'no-cache');
        postReq.setHeader('Cache-Control', 'no-cache');
        postReq.setHeader('X-XSS-Protection', '1');
        postReq.setHeader('x-content-type-options', 'nosniff');
        postReq.setHeader('SET-COOKIE', 'HttpOnly');
        postReq.setTimeout(60000);//The default timeout is 10 seconds.The maximum cumulative timeout for callouts by a single Apex transaction is 120 seconds. 
            //This time is additive across all callouts invoked by the Apex transaction.
        string paramValue ='objectIds=';
        for(string zip : zipDataMap.keyset()){
            list<RequestDataWrapper> requestWrapperList = new list<RequestDataWrapper>();
            requestWrapperList = zipDataMap.get(zip);
            for(RequestDataWrapper request : requestWrapperList){
            	paramValue += request.objectid+',';
            }
         }
       paramValue = paramValue.removeEnd(',');
       String body = paramValue+'&f=json';
       system.debug('body delete '+body);
       postReq.setBody(body);
       Http postHttp = new Http();
       system.debug('postReq .'+postReq);
       //sending request to ESRI

       HTTPResponse postRes = new HttpResponse();
        if(Test.isRunningTest()){
            ESRIServicesMockGenerator obj = new ESRIServicesMockGenerator();
            postRes = obj.respond(postReq);
        }
        else
            postRes = postHttp.send(postReq);

        if(postRes.getStatusCode() == 200){
            system.debug('Post request Passed.');
            system.debug('########## toBeDeletedPosGeo ' + toBeDeletedPosGeo);
            //Deleting Position Geography records from Salesforce.
            if(SecurityUtil.checkObjectIsDeletable(Position_Geography__c.SObjectType)){
               delete toBeDeletedPosGeo;
            }
        }else{
            system.debug('Oops something went wrong in post request');
        }
     }

    /*@author : Arun Kumar
    @date : 6 July 2017  
    @description : This method will generate the SOQL string     
    @return : string SOQL from Position Geography
    */
    public static string getPositionGeographyById(){
        //return 'select id,Team_Instance__c,Team_Instance__r.name,Effective_Start_Date__c,Effective_End_Date__c,Change_Status__c, Geography__r.name, Position__r.Client_Position_Code__c, Position__r.Name, Position__c, Position__r.Parent_Position__r.Name, Position__r.Parent_Position__r.Client_Position_Code__c, Position__r.Parent_Position__r.Parent_Position__r.Name, Position__r.Parent_Position__r.Parent_Position__r.Client_Position_Code__c, Position__r.Parent_Position__r.Parent_Position__r.Parent_Position__r.Name, Position__r.Parent_Position__r.Parent_Position__r.Parent_Position__r.Client_Position_Code__c,Position__r.Parent_Position__r.Parent_Position__r.Parent_Position__r.Parent_Position__r.Name, Position__r.Parent_Position__r.Parent_Position__r.Parent_Position__r.Parent_Position__r.Client_Position_Code__c,Team_Instance__r.Alignment_Period__c,Team_Instance__r.Team__r.Name,Team_Instance__r.Team__r.type__c from Position_geography__c ';
        /*SPD3404 CHANGE (Team_Instance__c) Name -> Team_Instance_Code__c*/
        return 'select id,Team_Instance__c,Team_Instance__r.Team_Instance_Code__c,Effective_Start_Date__c,Effective_End_Date__c,Change_Status__c, Geography__r.name, Position__r.Client_Position_Code__c, Position__r.Name, Position__c, Position__r.Parent_Position__r.Name, Position__r.Parent_Position__r.Client_Position_Code__c, Position__r.Parent_Position__r.Parent_Position__r.Name, Position__r.Parent_Position__r.Parent_Position__r.Client_Position_Code__c, Position__r.Parent_Position__r.Parent_Position__r.Parent_Position__r.Name, Position__r.Parent_Position__r.Parent_Position__r.Parent_Position__r.Client_Position_Code__c,Position__r.Parent_Position__r.Parent_Position__r.Parent_Position__r.Parent_Position__r.Name, Position__r.Parent_Position__r.Parent_Position__r.Parent_Position__r.Parent_Position__r.Client_Position_Code__c,Team_Instance__r.Alignment_Period__c,Team_Instance__r.Team__r.Name,Team_Instance__r.Team__r.type__c,Team_Instance__r.Team__r.Team_Code__c,IsShared__c,  Proposed_Position__c from Position_geography__c ';
    } 

    /*@author : Arun Kumar
    @date : 2 Aug 2017        
    @description : This method will create a ZIP wrapper for position geography record    
    @param1: list of position geography based on select ZIPs from the table view
    return map of Position ,ZIP,wrapper 
    @param2: contains movementType like ZIP Movement/Share and Account Movement
    @param3: contains id of ProposedPosition. 
    */

    public static map<string,list<RequestDataWrapper>> createZIPDataMapWrapper(list<Position_Geography__c> lstPosGeo, string movementType, set<id> position){
        map<string,list<RequestDataWrapper>> zipDataMap = new map<string,list<RequestDataWrapper>>();
        //below map will be usefull in case of Submission pending. Becasuse in order to send the Position's level 1 level2, leve3 code and name to ESRI, we are using
        //proposed position fields and that field is external ID. As a result of this we can't fetch lookup fields upto parent level.
        map<string, Position__c> mapPosition = new map<string, Position__c>();
        if(position.size()> 0){

            list<Position__c> lstPosition = SalesIqUtility.getPositionById(position);
            for(Position__c propPos: lstPosition){
                mapPosition.put(propPos.id,propPos);
            }

        }                

        try{      
              
            for(Position_Geography__c posGeo:lstPosGeo){
                    //SPD-3051 Scenario- On CR Tracking disabled, zip is not getting locked as Future Active
                    //Added below condition because in case of CR of, we don't fill Status at while creating new Position geography record
                    //If chnage posGeo.Change_Status__c is blank, we are assumning that this request is coming due to CR tracking Off
                    string status = '';
                    if(!string.isBlank(posGeo.Change_Status__c)){
                        status = posGeo.Change_Status__c;
                    }else{
                        
                        status = SalesIQGlobalConstants.REQUEST_STATUS_APPROVED;
                    }
                    if(movementType==SalesIQGlobalConstants.MOVEMENT_TYPE_ZIP_SHARING){
                    	//Applying this condition to handle update call to ESRI where we need to send ZIP_Status.
                    	if(posGeo.IsShared__c){
                           status =SalesIQGlobalConstants.ESRI_SHARED_STATUS;
                    	}else{
                    	   status = 'UNLOCKED';
                    	}
                    }else if(movementType==SalesIQGlobalConstants.REQUEST_STATUS_SUBMISSION_PENDING || movementType==SalesIQGlobalConstants.REQUEST_STATUS_DELETE_SUBMISSION_PENDING){
                        status = movementType;

                    }                 
                    
                    RequestDataWrapper reqData;       
                    if(movementType==SalesIQGlobalConstants.REQUEST_STATUS_SUBMISSION_PENDING){
                        //This will execute in case of Submission pending because we need to use proposed position field in order to send the destination to ESRI
                         reqData = new RequestDataWrapper(posGeo.Geography__r.name,status,
                                        mapPosition.get(posGeo.Proposed_Position__c).Client_Position_Code__c, 
                                        mapPosition.get(posGeo.Proposed_Position__c).Name,
                                        mapPosition.get(posGeo.Proposed_Position__c).Parent_Position__r.Client_Position_Code__c,
                                        mapPosition.get(posGeo.Proposed_Position__c).Parent_Position__r.Name,
                                        mapPosition.get(posGeo.Proposed_Position__c).Parent_Position__r.Parent_Position__r.Client_Position_Code__c,
                                        mapPosition.get(posGeo.Proposed_Position__c).Parent_Position__r.Parent_Position__r.Name,
                                        mapPosition.get(posGeo.Proposed_Position__c).Parent_Position__r.Parent_Position__r.Parent_Position__r.Client_Position_Code__c,
                                        mapPosition.get(posGeo.Proposed_Position__c).Parent_Position__r.Parent_Position__r.Parent_Position__r.Name,  
                                        mapPosition.get(posGeo.Proposed_Position__c).Parent_Position__r.Parent_Position__r.Parent_Position__r.Parent_Position__r.Client_Position_Code__c,
                                        mapPosition.get(posGeo.Proposed_Position__c).Parent_Position__r.Parent_Position__r.Parent_Position__r.Parent_Position__r.Name,
                                        mapPosition.get(posGeo.Proposed_Position__c).Client_Position_Code__c,
                                        //posGeo.Team_Instance__r.Name,
                                        /*SPD3404 CHANGE (Team_Instance__c) Name -> Team_Instance_Code__c*/
                                        posGeo.Team_Instance__r.Team_Instance_Code__c,
                                        userinfo.getName(), posGeo.Effective_Start_Date__c > system.today() ? true : false,
                                        movementType,
                                        posGeo.Team_Instance__r.Alignment_Period__c,
                                        //posGeo.Team_Instance__r.Team__r.Name,
                                        /*SPD3404 CHANGE (Team__r) Name -> Team_Code__c*/
                                        posGeo.Team_Instance__r.Team__r.Team_Code__c,
                                        posGeo.Team_Instance__r.Team__r.Type__c
                                        );

                    }else{
                        system.debug('in else '+movementType);
                        reqData = new RequestDataWrapper(posGeo.Geography__r.name,status,
                                        posGeo.Position__r.Client_Position_Code__c, 
                                        posGeo.Position__r.Name,
                                        posGeo.Position__r.Parent_Position__r.Client_Position_Code__c,
                                        posGeo.Position__r.Parent_Position__r.Name,
                                        posGeo.Position__r.Parent_Position__r.Parent_Position__r.Client_Position_Code__c,
                                        posGeo.Position__r.Parent_Position__r.Parent_Position__r.Name,
                                        posGeo.Position__r.Parent_Position__r.Parent_Position__r.Parent_Position__r.Client_Position_Code__c,
                                        posGeo.Position__r.Parent_Position__r.Parent_Position__r.Parent_Position__r.Name,  
                                        posGeo.Position__r.Parent_Position__r.Parent_Position__r.Parent_Position__r.Parent_Position__r.Client_Position_Code__c,
                                        posGeo.Position__r.Parent_Position__r.Parent_Position__r.Parent_Position__r.Parent_Position__r.Name,
                                        posGeo.Position__r.Client_Position_Code__c,
                                        //posGeo.Team_Instance__r.Name,
                                        /*SPD3404 CHANGE (Team_Instance__c) Name -> Team_Instance_Code__c*/
                                        posGeo.Team_Instance__r.Team_Instance_Code__c,
                                        userinfo.getName(), posGeo.Effective_Start_Date__c > system.today() ? true : false,
                                        movementType,
                                        posGeo.Team_Instance__r.Alignment_Period__c,
                                        //posGeo.Team_Instance__r.Team__r.Name,
                                        /*SPD3404 CHANGE (Team__r) Name -> Team_Code__c*/
                                        posGeo.Team_Instance__r.Team__r.Team_Code__c,
                                        posGeo.Team_Instance__r.Team__r.Type__c
                                        );

                    }             
                    

                    if(zipDataMap.containsKey(posGeo.Geography__r.name)){
                        list<RequestDataWrapper> templist = zipDataMap.get(posGeo.Geography__r.name);
                        templist.add(reqData);
                        zipDataMap.put(posGeo.Geography__r.name,templist);

                    }else{
                        zipDataMap.put(posGeo.Geography__r.name,new list<RequestDataWrapper>{reqData});
                    }
                }
            }catch(exception ex){
                system.debug('error in createZIPDataMapWrapper '+ex.getMessage());

            }
            return zipDataMap;
    }
  

    public class RequestDataWrapper{
        public string status{get;set;}
        public string zip{get;set;}
        public string last_edited_sfdc_user{get;set;}
        public integer objectid{get;set;}
        public string level1_code{get;set;}
        public string level1_name{get;set;}
        public string level2_code{get;set;}
        public string level2_name{get;set;}
        public string level3_code{get;set;}
        public string level3_name{get;set;}
        public string level4_code{get;set;}
        public string level4_name{get;set;}
        public string level5_code{get;set;}
        public string level5_name{get;set;}
        public string destination_territory{get;set;}
        public string team_instance_name{get;set;}
        public boolean isFuture{get;set;}
        public string crType{get;set;} 
        public string alignmentPeriod{get;set;}
        public string team_name{get;set;}
        public string team_type{get;set;}
        
        // new constructor added, code changes by Aditi, SPD-261
        public requestDataWrapper(String zip, String status, Position__c source, Position__c destination, String teamInstanceName, String userName, boolean isFuture, string crType,string alignmentPeriod) {
            this.zip = zip ;
            this.status = status;
            this.level1_code = source.Client_Position_Code__c;
            this.level1_name = source.Name;
            this.level2_code = source.Parent_Position__r.Client_Position_Code__c;
            this.level2_name = source.Parent_Position__r.Name;
            this.level3_code = source.Parent_Position__r.Parent_Position__r.Client_Position_Code__c;
            this.level3_name = source.Parent_Position__r.Parent_Position__r.Name;
            this.level4_code = source.Parent_Position__r.Parent_Position__r.Parent_Position__r.Client_Position_Code__c;
            this.level4_name = source.Parent_Position__r.Parent_Position__r.Parent_Position__r.Name;
            this.level5_code = source.Parent_Position__r.Parent_Position__r.Parent_Position__r.Parent_Position__r.Client_Position_Code__c;
            this.level5_name = source.Parent_Position__r.Parent_Position__r.Parent_Position__r.Parent_Position__r.Name;
            this.destination_territory = destination.Client_Position_Code__c;
           // this.team_instance_name = team_instance_name;
            this.team_instance_name = teamInstanceName;
            this.last_edited_sfdc_user = userName;
            this.isFuture = isFuture;
            this.crType = crType;
            this.alignmentPeriod = alignmentPeriod;
        }

        public requestDataWrapper(string zip, string status, string level1_code, string level1_name, string level2_code, string level2_name, string level3_code, string level3_name,string level4_code ,string level4_name, string level5_code, string level5_name, string destination_territory, string team_instance_name, string userName, boolean isFuture, string crType,string alignmentPeriod, string team_name, string team_type){
            this.zip = zip;
            this.status = status;
            
            this.level1_code = level1_code;
            this.level1_name = level1_name;
  
            this.last_edited_sfdc_user = userName;
            
            if(level2_code !=null){
            	this.level2_code = level2_code;
            	this.level2_name = level2_name;
            }else{
            	this.level2_code = '';
            	this.level2_name = '';           
            }
            
            if(level3_code !=null){
            	this.level3_code = level3_code;
            	this.level3_name = level3_name;
            }else{
                this.level3_code = '';
            	this.level3_name = '';
            }
            
            if(level4_code!=null){
                 this.level4_code = level4_code;
                 this.level4_name = level4_name;
            }else{
                 this.level4_code = '';
                 this.level4_name = '';
            }
            
            if(level5_code!=null){
                 this.level5_code = level5_code;
                 this.level5_name = level5_name;
            }else{
                 this.level5_code = '';
                 this.level5_name = '';
            }
            
            this.destination_territory = destination_territory;
            this.team_instance_name = team_instance_name;
            this.isFuture = isFuture;
            this.crType = crType;
            this.alignmentPeriod = alignmentPeriod;
            if(!string.isBlank(team_name)){
                this.team_name = team_name;
            }else{
                this.team_name ='';
            }

            if(!string.isBlank(team_type)){
                this.team_type = team_type;
            }else{
                this.team_type ='';
            }
        }
    }

    public class TerritoryWrapper{
        public String territory_code{get;set;}
        public String territory_name{get;set;}
        public Integer objectid{get;set;}
        public TerritoryWrapper(Integer objectid){
			this.objectid = objectid;
        }
    }
}